#ifndef __REVIRT_CHECKPOINT_H
#define __REVIRT_CHECKPOINT_H

#include <linux/sched.h>
#include <revirt/rlog.h>
#include <revirt/ztrace.h>

static inline int revirt_get_tuple(struct revirt_tuple * tuple, struct task_struct *tsk) {
	struct revirt_ctrdata ctr;
	if(tsk->revirt_tsk && tsk->revirt_tsk->group) {
	    copy_branchdata(tsk, &ctr);
	    tuple->bc = ctr.hw_branch;
	    tuple->rhid = tsk->revirt_tsk->group->zt_ctl.last_sched_id;	    
	    return 0;
	} else {
	    return -EINVAL;
	}
}

static inline struct task_struct * revirt_get_sched(struct task_struct * tsk) {
	if(!(revirt_options.replayflags & REPLAY_OPT_NOCHKPT_ZR)
		&& tsk->revirt_tsk)
		return tsk->revirt_tsk->sched;
	else
		return NULL;
}

#define MAX_CHECKPOINT_PIDS 2

struct revirt_checkpoint_struct {
    int nrpids;
    struct revirt_group_struct group;
    struct {
     int pid;
     struct revirt_tsk_s rtsk;
     int revirt_flags;
     unsigned long eip;
    } proc [MAX_CHECKPOINT_PIDS];
};


//struct revirt_checkpoint_struct * revirt_take_replay_checkpoint(struct task_struct * );
struct revirt_checkpoint_struct * revirt_take_checkpoint(struct task_struct * );
int revirt_restore_checkpoint(struct task_struct *, struct task_struct *, struct revirt_checkpoint_struct *);
int revirt_free_checkpoint(struct revirt_checkpoint_struct *);

#endif
