/*
 * flags.h - Flags for the revirt system.  May be included from .S file.
 *
 * Copyright (C) 2002 George Dunlap
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#define REPLAY_UML_TAILORED 1

/* replay flags */
#define REPLAY_NONE   (0)
#define REPLAY_LOG    (1)
#define REPLAY_REPLAY (1 << 1)
#define REPLAY_SSTEP  (1 << 2)
#define	REPLAY_FIRST_AFTER_SIG (1 << 3)
#define REPLAY_PROCESS_IN_UMODE (1 << 4)
#define REPLAY_DMA	(1 << 5)
#define REPLAY_INT3  (1 << 6)
#define REPLAY_WAIT (1 << 7)
#define REPLAY_AT_EXIT (1 << 8)
#define REPLAY_DELAY_PERF (1 << 9)
#define REPLAY_SCHED (1 << 10)
#define REPLAY_IN_COPY_USER (1 << 11)
#define REPLAY_DATASQUASH (1 << 12)
#define REPLAY_XUSER (1 << 13) 
#define REPLAY_ZOMBIE (1 << 14)
#define REPLAY_SYSCALL (1 << 15)
#define REPLAY_PTRACE (1 << 16)
#define REPLAY_NO_YIELD_ON_BLOCK (1 << 17)
#define REPLAY_SUPPRESS_SCHED (1 << 18)
#define REPLAY_SIGBLOCK (1 << 19)
#define REPLAY_SYNC_BLOCK (1 << 20)
#define REPLAY_EMULATE_RDTSC (1 << 21)
#define REPLAY_ZTRACE_CAN_CHECKPOINT (1 << 22)
#define	REPLAY_USER_TRAP (1 << 23)

#define RFLAGS_MAX 24
#define RFLAGS_NAMES { \
	 "LOG", "REPLAY", "SSTEP", "FIRST_AFTER_SIG", "PROCESS_IN_UMODE", \
	 "DMA", "INT3", "WAIT", "AT_EXIT", "DELAY_PERF", "SCHED", 	\
	 "IN_COPY_USER", "DATASQUASH", "XUSER", "ZOMBIE", "SYSCALL", \
	 "PTRACE", "NO_YIELD_ON_BLOCK", "SUPPRESS_SCHED", "SIGBLOCK",\
	 "SYNC_BLOCK", "EMULATE_RDTSC", "ZTRACE_CAN_CHECKPOINT", "USER_TRAP" }



#define REPLAY_TSK_GETSTATE(x) (((x) >> 24) & 0xF)
#define REPLAY_TSK_SETSTATE(x) (((x) & 0xF) << 24)

