#define WRAW_GRAB 	_IO( 0xac, 0 )
#define WRAW_LISTEN 	_IO( 0xac, 1 )
#define WRAW_RELEASE 	_IO( 0xac, 2 )


struct wraw_grab_arg_s { 
    loff_t maxoffset;
    /* maxwr defines both the size of written_u array AND number of
     * pages within databuf_u.  These must be the same. */
};

struct wraw_listen_arg_s {
    unsigned int * datamap_u;
    loff_t * written_u;
    char * databuf_u;
    int maxwr;
    int curwr;
};

#define OFF2BYTE(x)  ((x) >> (12 + 5))  /* 12: 4096-byte page; 5: 32 bits*/
#define OFF2BIT(x) (((x) >> 12) & 31 )
#define BB2OFF(x,y)  (((((loff_t)(x)) << 5) + (y)) << 12)
#define DBUFGRAIN (4096)

#ifdef __KERNEL__

//#define DBUFSIZE (4096*1024)
#define WBUFSIZE (512)

#define ACCESS_RD 0
#define ACCESS_WR 1

struct wraw_watch_s {
    int watched;
    struct task_struct * tsk;

    struct semaphore mutex;
    wait_queue_head_t wait_read;
    wait_queue_head_t wait_write;

    unsigned int * datamap_u;
//    char * datamap_k;
    loff_t maxoffset;
    unsigned int maxindex;

    loff_t * written_u;
    int maxwr;
    int curwr;
    int err;

    char * databuf_u;
    struct kiobuf  * iovec_page[WBUFSIZE];
};

#endif
