#ifndef __COW_DISK_H__
#define __COW_DISK_H__

#define COW_BLOCK_SIZE 512
#define COW_BLOCK_SHIFT 9

#define UML_COW_NEGATIVE_INFINITY ((unsigned long long)(-1LL))
#define UML_COW_POSITIVE_INFINITY ((unsigned long long)(-2LL))

typedef struct cow_disk_struct *cow_disk_t;

cow_disk_t newCowDisk(char *baseName);
void closeCowDisk(cow_disk_t cow, struct file *file);

// for when you open in replay mode and you want to append existing
// cow files.  This is probably to reset a cow disk.  It uses the
// basename and id to form the filename for the records
void appendCowCheckpoint(cow_disk_t cow, unsigned long long id);

// when you open an existing cow file, this is used to let the
// cow disk know where the state of the target disk is
int setCowCurrId(cow_disk_t cow, unsigned long long id);

void writeCowDisk(cow_disk_t cow, int diskFd, loff_t offset);

unsigned long long setNewCheckpoint(cow_disk_t cow, struct file *file);
int goToCheckpoint(cow_disk_t cow, unsigned long long id, struct file *file);
void deleteCheckpoint(cow_disk_t cow, unsigned long long id);

//void resetDisk(cow_dist_t cow, int diskFd);

// for speculative data
#include "checkpoint.h"
sparse_file_t getCowSf(cow_disk_t cow);

#endif
