#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/version.h>
#include <linux/errno.h>
#include <linux/unistd.h>
#include <linux/string.h>
#include <linux/types.h>
#include <linux/param.h>
#include <linux/fs.h>
#include <asm/uaccess.h>
#include <linux/slab.h>

#include <linux/interrupt.h>

#include <linux/ptrace.h>
#include <asm/ptrace.h>
#include <asm/signal.h>
#include <asm/io.h>
#include <linux/mman.h>
#include <linux/mm.h>
#include <linux/sched.h>

#include <asm/system.h>
#include <asm/segment.h>
#include <asm/desc.h>

#include <linux/pci.h>

#include <linux/vmalloc.h>
#include <asm/semaphore.h>

#include <asm/pgalloc.h>

#include <linux/file.h>
#include <linux/poll.h>

#include <asm/irq.h>

#include "myutil.h"

// for making this a device driver
static int major;
static char name[] = "umldma";
static struct file_operations op;

static int umldma_open(struct inode *inode, struct file *file);
static int umldma_release(struct inode *i, struct file *f);
static ssize_t umldma_write(struct file *f, const char *buf, size_t len, loff_t *p);
static ssize_t umldma_read(struct file *f, char *buf, size_t len, loff_t *p);
static int umldma_ioctl(struct inode *inode, struct file *f,
		     unsigned int cmd, unsigned long arg);
static unsigned int umldma_poll(struct file *filp, struct poll_table_struct *wait);

static int umldma_mmap(struct file *filp, struct vm_area_struct *vma);

/**
 * linux module stuff
 */
int init_module(void) {
  /**
   * set up the device driver functions
   */
  memset(&op, 0, sizeof(op));
  
  op.open = &umldma_open;
  op.release = &umldma_release;
  op.write = &umldma_write;
  op.read = &umldma_read;
  op.ioctl = &umldma_ioctl;
  op.poll = &umldma_poll;
  op.mmap = &umldma_mmap;

  major = register_chrdev(0,name,&op);
  if(major < 0)
    return -1;

  return 0;
}

void cleanup_module(void) {
  unregister_chrdev(major,name);
}

/**
 * these are the device driver functions, they are used so that user mode applications
 * can read the system call and other data.
 */
static int umldma_mmap(struct file *filp, struct vm_area_struct *vma) {
  printk("mmap umldma\n");
  return 0;
}
static unsigned int umldma_poll(struct file *filp, struct poll_table_struct *wait) {
  unsigned int ret = 0;

  assert(0);
  return ret;
}

static int umldma_open(struct inode *inode, struct file *file) {
  file->f_pos = 0;
  
  printk("open umldma\n");

  MOD_INC_USE_COUNT;

  return 0;
}

static int umldma_release(struct inode *i, struct file *f) {
  MOD_DEC_USE_COUNT;

  if(!MOD_IN_USE) {

  }

  return 0;
}

static ssize_t umldma_write(struct file *f, const char *buf, size_t len, loff_t *p) {
  assert(0);
  return 0;
}


static ssize_t umldma_read(struct file *f, char *buf, size_t len, loff_t *p) {
  assert(0);
  return 0;
}


static int umldma_ioctl(struct inode *inode, struct file *f,
			 unsigned int cmd, unsigned long arg) {

  assert(0);
  return 0;
}

 
