// this is for the kernel implementation of the memory utilities
#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/version.h>
#include <linux/errno.h>
#include <linux/unistd.h>
#include <linux/string.h>
#include <linux/types.h>
#include <linux/param.h>
#include <linux/fs.h>
#include <linux/slab.h>
#include <linux/vmalloc.h>

#include <asm/uaccess.h>

#include <asm/signal.h>
#include <linux/mman.h>

#include <asm/system.h>
#include <asm/segment.h>

#include <asm/semaphore.h>

#include "myutil.h"

void *util_alloc_small(unsigned long size) {
  void *mem = kmalloc(size, GFP_KERNEL);
  assert(mem != NULL);
  return mem;
}
void util_free_small(void *mem) {
  assert(mem != NULL);
  kfree(mem);
}
void *util_alloc_large(unsigned long size) {
  void *mem = vmalloc(size);
  assert(mem != NULL);
  return mem;
}
void util_free_large(void *mem) {
  assert(mem != NULL);
  vfree(mem);
}
