#include <stdlib.h>
#include <stdio.h>

#include <unistd.h>
#include <asm/unistd.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <errno.h>

#include <ctype.h>

#include <revirt/rlog.h>
#include <revirt/flags.h>

/*
 * So asm/siginfo.h will compile...
 */
typedef long clock_t;

#include <asm/siginfo.h>

#define BUFSIZE (1024 * 1024) 
unsigned char buf[BUFSIZE];

int main(int argc, char * argv[]) {
	int fd, ofd;
	int ar[2], i, j, l;
	struct rlog_header rh;
	struct rlog_entry_sysret *sr;

	if(argc<3) {
		fprintf(stderr, "Usage: %s logfile ofile\n", argv[0]);
	}
	printf("Opening file %s\n", argv[1]);
	if((fd=open(argv[1], O_RDONLY))<0) {
		perror("opening input file");
		exit(1);
	}
	if((ofd=open(argv[2], O_WRONLY|O_CREAT)) <0) {
		perror("opening output file");
		exit(1);
	}
	while((l=read(fd, &rh, sizeof(rh)))>0) {
		if((l=read(fd, buf, rh.len))<rh.len) {
			if(l<0)
				perror("reading file");
			else
				fprintf(stderr, "Bad file format: wanted %d, got %d\n", rh.len, l);
			exit(1);
		}
		switch(rh.type) {
		    case ENTRY_SYSRET:
		     	sr=(struct rlog_entry_sysret *) buf;
			switch(sr->syscall) {
				case 47:
				case 179:
				case 235:
				case 236:
					i=1;
					break;
				default:
					i=0;
					break;
			}
			if(i)
			    break;
		    default:
		    	if(write(ofd, &rh, sizeof(rh))<0) {
				perror("write");
				exit(1);
			}
		    	if(write(ofd, buf, rh.len)<0) {
				perror("write");
				exit(1);
			}
		}
	}
}
		
int printdata(char *buf, int l) {	
	int i, j;
		for(i=0; i<l; i+=16) {
		    printf(" %08x:", i);
		    for(j=i; j<i+16 && j<l; j++) {
			if (!(j%4) && j>0)
				printf(" ");
			printf("%02x ", (unsigned int)buf[j]);
                    }
		    if(j<i+16) {
			for(; j<i+16; j++) {
				if(!j%4)
					printf("  ");
				printf("   ");
			}
		    }
		    printf("  ");
		    for(j=i; j<i+16; j++) {
			if(isprint(buf[j]))
				fputc(buf[j], stdout);
			else
				fputc('.', stdout);
		    }
		    printf("\n");
		}
}
