#include <stdlib.h>
#include <stdio.h>

#include <unistd.h>
#include <asm/unistd.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <errno.h>

#include <ctype.h>

#include <linux/autoconf.h>
#include <revirt/rlog.h>
#include <revirt/flags.h>

#include "library.h"

/*
 * So asm/siginfo.h will compile...
 */
typedef long clock_t;

//#include <asm/siginfo.h>

#define BUFSIZE (1024 * 1024) 
unsigned char buf[BUFSIZE];

int check_rhid(struct rlog_header *rh) {
    if(rh->type == ENTRY_SCHED) 
    	return 1;
    else
    	return 0;
}

int check_entry(struct rlog_header *rh, char * buf) {
    struct rlog_schedule_entry * le=(typeof(le))buf;

    if(le->ctr.hw_branch == 0
    	&& le->wchan==0
    	&& ((le->flags & REPLAY_SIGBLOCK) 
		== (REPLAY_SIGBLOCK))) {
	return 1;
    } else {
    	return 0;
    }
}

int main(int argc, char * argv[]) {
	int fd;
	int l;
	unsigned from, to;
	struct rlog_header rh;

	if(argc==2) {
		from=0; 
		to=0;
	} else if(argc==3){
		from=atoi(argv[2]);
		to=from;
	} else if (argc==4) {
		from=atoi(argv[2]);
		to=atoi(argv[3]);
	} else {
		fprintf(stderr, "Usage: %s logfile [from [to]]\n", argv[0]);
		exit(1);
	}

	printf("Opening file %s\n", argv[1]);
	if((fd=open(argv[1], O_RDONLY))<0) {
		perror("opening file");
		exit(1);
	}
	if(to>0) {
		fprintf(stderr, "Searching for record %d...\n", from);
	}
	while((l=read(fd, &rh, sizeof(rh)))>0) {
		/*
		 * Give the user some idea where you are...
		 */
		if(!(rh.id %500000)) {
			fprintf(stderr, "%d...\n", rh.id);
		}

		/* 
		 * Check to see if this rhid is a potential or not.  If so,
		 * read in the data; else, seek to the next one.
		 */
		if(check_rhid(&rh)) {
		    if((l=read(fd, buf, rh.len))<rh.len) {
			if(l<0)
				perror("reading file");
			else
				fprintf(stderr, "Bad file format: wanted %d, got %d\n", rh.len, l);
			exit(1);
		    }
		    /*
		     * Now check to see if this is a log we want to print; if
		     * so, print it.
		     */
		    if(check_entry(&rh, buf)) {
			print_entry(rh, buf);
		    }
		} else {
		    if((l=lseek(fd, rh.len, SEEK_CUR))<0) {
		    	perror("lseek");
		    }
		}

		if(to>0 && rh.id >= to)
			break;
	}
	return 0;
}
