#include <stdlib.h>
#include <stdio.h>

#include <unistd.h>
#include <asm/unistd.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <errno.h>

#include <ctype.h>

#include <linux/autoconf.h>
#include <revirt/rlog.h>
#include <revirt/flags.h>

#include "library.h"

/*
 * So asm/siginfo.h will compile...
 */
typedef long clock_t;

//#include <asm/siginfo.h>

#define BUFSIZE (1024 * 1024) 
unsigned char buf[BUFSIZE];

int main(int argc, char * argv[]) {
	int fd;
	int l;
	unsigned from, to;
	struct rlog_header rh;

	if(argc==2) {
		from=0; 
		to=0;
	} else if(argc==3){
		from=atoi(argv[2]);
		to=from;
	} else if (argc==4) {
		from=atoi(argv[2]);
		to=atoi(argv[3]);
	} else {
		fprintf(stderr, "Usage: %s logfile [from [to]]\n", argv[0]);
		exit(1);
	}

	printf("Opening file %s\n", argv[1]);
	if((fd=open(argv[1], O_RDONLY))<0) {
		perror("opening file");
		exit(1);
	}
	if(to>0) {
		fprintf(stderr, "Searching for record %d...\n", from);
	}
	while((l=read(fd, &rh, sizeof(rh)))>0) {
		if((l=read(fd, buf, rh.len))<rh.len) {
			if(l<0)
				perror("reading file");
			else
				fprintf(stderr, "Bad file format: wanted %d, got %d\n", rh.len, l);
			exit(1);
		}
		if(rh.id >= from) 
			print_entry(rh, buf);
		else if(to>0 && !(rh.id %500000)) {
			fprintf(stderr, "%d...\n", rh.id);
		}

		if(to>0 && rh.id >= to)
			break;
	}
	return 0;
}
