#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/resource.h>
#include <sys/poll.h>
#include <fcntl.h>
#include <errno.h>
#include <signal.h>

#define BUFSIZE (1 << 22)

char * buf [BUFSIZE];
int live=1;
int rfd, wfd;
int len;

unsigned long total = 0;

#define __NR_ugetrlimit 191

int main(int argc, char * argv[]) {
	struct rlimit rl;
	char *ofname;
	struct pollfd pfd;
	int r;

	rl.rlim_cur=(~0UL);
	rl.rlim_max=(~0UL);
	//printf("setrlimit: %ul, %ul\n", rl.rlim_cur, rl.rlim_max);
	if(setrlimit(RLIMIT_FSIZE, &rl)) {
		perror("Setting rlimit_fsize to rlim_infinity");
	}

	syscall(__NR_ugetrlimit, RLIMIT_FSIZE, &rl);
	//printf("getrlimit: %ul, %ul\n", rl.rlim_cur, rl.rlim_max);

	if((rfd=open("/proc/rlog", O_RDONLY,0664))<0) {
		perror("Opening /proc/rlog");
		exit(1);
	}
	printf("/proc/rlog opened.\n");

	if(argc > 1)  {
	    ofname=argv[1];
	    if((wfd = open(ofname, 
	    			O_CREAT|O_TRUNC|O_WRONLY, 
				S_IRUSR|S_IWUSR|S_IRGRP|S_IWGRP|S_IROTH))<0) {
		perror("Opening output file");
		exit(1);
	    }
	    printf("File %s opened for writing.\n", ofname);
	} else {
	    wfd=0;
	}

	printf("Polling for unread data...\n");

	pfd.fd = rfd;
	pfd.events = POLLIN;
	r=poll(&pfd, 1, 0);
	if((r > 0) && (pfd.revents & POLLIN)) {
		/*
 		 * FIXME this assumes BUFSIZE is greater than kernel BUFSIZE
		 */
		printf("Calling read...\n");
		if((len=read(rfd, buf, BUFSIZE)) < 0) 
			perror("reading file");
		else {
			total+=len;
			printf("Read %d bytes (%lu total)\n", len, total);
			if(wfd) {
			    if(write(wfd, buf, len)<0) {
			    	perror("Writing file");
			    }
			}
			
		}
	} else if(r < 0) {
		perror("poll");
	} else
		printf("Poll returns 0.\n");
	close(rfd);
	if(wfd)
	    close(wfd);
	return 1;
}
