#!/usr/bin/perl
use strict;
use Getopt::Std;

my $omitDrivers = 0;
my $arch = "";

sub countLines($) {
    my ($f) = @_;
    my ($file);
    my $line;
    my $count;

    open($file, "<$f") || die("could not open $f");
    $count = 0;
    while($line = <$file>) {
	$count++;
    }
    
    close($file);


    return $count;
}
    
sub checkDirs($$) {
    my ($cwd,$count) = @_;
    my $f;

    if(index($cwd,"./arch/") == 0 && ($cwd ne "./arch/")) {
	if(index($cwd,"./arch/$arch") != 0) {
	    return $count;
	}
    }

    if((index($cwd,"./arch/") == 0) && ($arch eq "neither")) {
	return $count;
    }

    if($omitDrivers && (index($cwd,"./drivers") == 0)) {
	return $count;
    }

    foreach $f (<*>) {
	$_ = $f;
	if(/\.c$/ || /\.S$/) {
	    $count += countLines($f);
	}
    }

    foreach $f (<*>) {
	if( -d $f) {	    
	    chdir($f);
	    $count = checkDirs($cwd . $f . "/", $count);
	    chdir("..");
	}
    }

    return $count;
}

sub main {
    my %options;
    my $res;

    getopts("da:", \%options);

    if(!$options{"a"} || 
       !(($options{"a"} eq "um") || ($options{"a"} eq "i386") ||
	 ($options{"a"} eq "neither"))) {
	print STDERR "usage: -d -a (um|i386|neither)\n";
	print STDERR "-a    -- arch\n";
	print STDERR "-d    -- omit drivers\n";
	exit(1);
    }

    $omitDrivers = $options{"d"};
    $arch = $options{"a"};
    $res = checkDirs("./",0);

    print "$res\n";
}

main();
