#include <linux/config.h>
#include <linux/slab.h>
#include <linux/init.h>
#include <linux/unistd.h>
#include <linux/smp_lock.h>
#include <linux/module.h>
#include <linux/vmalloc.h>
#include <linux/completion.h>
#include <linux/namespace.h>
#include <linux/personality.h>
#include <linux/compiler.h>

#include <asm/pgtable.h>
#include <asm/pgalloc.h>
#include <asm/uaccess.h>
#include <asm/mmu_context.h>

#define __NR_ztrace 276
#define ZTRACE_MARKER 32

static inline int ztrace(int command,int pid,unsigned long addr,void *data) {
      int ret;
      ret= syscall(__NR_ztrace, command, pid, addr, data);
      return ret;
}


int sys_gwd_syscall(int command, unsigned long a, unsigned long b, unsigned long c) {
    switch(command) {
    	case 0:
	    printk("sys_gwd: log marker %d\n", a);
	    return ztrace(ZTRACE_MARKER, a, 0,0);
	default:
	    printk("sys_gwd: unknown command %d\n", command);
	    return 0;
    }
}
