#!/usr/bin/perl
use strict;

my $MAKE = "Makefile.stk";
my $EXE_CONF = "exe.conf";
open(EXE_CONF_FILE,"<" . $EXE_CONF) || die("could not open conf file $EXE_CONF");
open(MAKE_FILE, ">" . $MAKE) || die("could not open make file $MAKE");

print MAKE_FILE "all: plato.conf\n\nplato.conf: ";

my $line;
my @vals;
my $cmd;
while($line = <EXE_CONF_FILE>) {
    $_ = $line;
    if(/^(\S+[:]\S+)\s*$/) {
	if(substr($1,0,1) ne "#") {
	    @vals = split(/:/,$1);	
	    print MAKE_FILE $vals[1] . ".plato.conf ";
	}
    }
}
print MAKE_FILE "\n";
print MAKE_FILE "\tcat *.plato.conf > plato.conf\n";
print MAKE_FILE "\tcat *.guestStructs.h > guestStructs.h\n";
print MAKE_FILE "\tcp plato.conf ../introspect/\n";
print MAKE_FILE "\tcp guestStructs.h ../introspect/\n";
print MAKE_FILE "\tcd ../introspect; make\n";
print MAKE_FILE "\n";

seek(EXE_CONF_FILE, 0, 0);
while($line = <EXE_CONF_FILE>) {
    $_ = $line;
    if(/^(\S+[:]\S+)\s*$/) {
	if(substr($1,0,1) ne "#") {
	    @vals = split(/:/,$1);	
	    print MAKE_FILE $vals[1] . ".plato.conf: ";
	    print MAKE_FILE $vals[1] . ".break.conf " .
		$vals[1] . ".structs.conf " . $vals[1] . ".globals.conf " .
		$vals[0] . "\n";
	    $cmd = "./gen_exe_data.pl -o " . $vals[0] . " -b " . $vals[1] .
		" -c " . $vals[1] . ".break.conf -g " . $vals[1] .
		".globals.conf -s " . $vals[1] . ".structs.conf";
	    if($vals[2] ne "") {
		$cmd .= " -u " . $vals[2];
	    }
	    print MAKE_FILE "\trm -f plato.conf\n";
	    print MAKE_FILE "\trm -f guestStructs.h\n";
	    print MAKE_FILE "\t" . $cmd . "\n";
	    print MAKE_FILE "\tmv plato.conf " . $vals[1] . ".plato.conf\n";
	    print MAKE_FILE "\tmv guestStructs.h " . $vals[1] . ".guestStructs.h\n";

	    print MAKE_FILE "\n";
	}
    }
}
print MAKE_FILE "\n";

print MAKE_FILE "clean:\n";
print MAKE_FILE "\trm -f *.plato.conf *.guestStructs.h\n";
print MAKE_FILE "\trm -f plato.conf guestStructs.h\n";
