#!/usr/bin/perl
use strict;

sub main {
    my($confFile,$elfFile);
    my($line, @funcs);
    my($f,$cont);

    $elfFile = $ARGV[0];
    $confFile = $ARGV[1];

    if(!$elfFile || !$confFile) {
	print "usage: parseFuncs.pl elf_file conf_file\n";
	exit 1;
    }
    if(!(-e $elfFile)) {
	print "the file $elfFile does not exists\n";
	exit 1;
    }

    if(!(-e $confFile)) {
	print "the file $confFile does not exist\n";
	exit 1;
    }

    # open the files config file and process each of the entries
    open(CONFIG,"<$confFile") or die "could not open $confFile\n";
    while( $line = <CONFIG> ) {
	$_ = $line;
        if(! /^\#.*/ ) {
            $_ = $line;
            if( /\s*(\w+)\s*/ ) {
                push @funcs, $1;
            }
        }
    }
    close(CONFIG);

    foreach $f (@funcs) {
	open(ELF,"<$elfFile") or die "could not open $elfFile\n";

	print "***BEGIN\n";
	print "functionName $f\n";
	while( $line = <ELF> ) {
	    $_ = $line;
	    if( /^(\w{8,8}) \<$f\>\:/ ) {
		print "entryAddr $1\n";
	    }
	}
	print "***END\n";

	close(ELF);
    }
}


main();
