#!/usr/bin/perl
use strict;

sub getAddr($$) {
    my ($query,$objFile) = @_;
    my ($addr,$line);
    my $GDB;

    open($GDB,"./queryGdb $objFile $query |") || die("could not open queryGdb");
    
    $addr = "";
    while($line = <$GDB>) {
	$_ = $line;
	if(/address ([a-f,0-9,x]+)\.\s*$/) {
	    $addr = $1;
	}
    }
    
    if($addr eq "") { 
	die("could not find address from queryGdb quer = " . $query); 
    }
    close($GDB);
    
    return hex($addr);
}

sub printRes($$) {
    my($userModeComm, $globalVars) = @_;
    my $name;
    my @names = keys(%$globalVars);
    my $len = @names;

    if($len > 0) {
	print "***BEGIN\n";
	if($userModeComm ne "") {
	    if(index($userModeComm,"/") >= 0) {
		print "userModeSharedLib $userModeComm\n";
	    } else {
		print "userModeComm $userModeComm\n";
	    }
	}
	print "breakId GLOBAL_VARS\n";

	foreach $name (@names) {
	    print "variable " . $name . " DW_OP_addr " . 
		$globalVars->{"$name"} . "\n";
	}

	print "***END\n";
    }
}

sub main() {
    my ($objFile, $confFile, $userModeComm) = @ARGV;
    my %globalVars;
    my ($name, $query, $line);

    if(!$objFile || !$confFile) {
	print "usage: parseGlobals.pl object_file conf_file [userModeComm]\n";
	exit 1;
    }

    if(!(-e $objFile) || !(-e $confFile)) {
	die "one of your command line argument file names does not exist\n";
    }    

    open(CONF_FILE,"<" . $confFile) || die("could not open file $confFile");

    while($line = <CONF_FILE>) {
	$_ = $line;
	if(! /^\s*\#/ && !/^\s*$/) {
	    $name = "";
	    $query = "";
	    $_ = $line;
	    if(! /^\s*(\S+)\s+(\".+\")\s*$/ ) {
		die("could not parse line $line");
	    }
	    $name = $1;
	    $query = $2;
	    
	    $globalVars{"$name"} = getAddr($query,$objFile);
	}	           
    }

    printRes($userModeComm, \%globalVars);
}

main();
