#include <stdio.h>
#include <stdlib.h>

#include <unistd.h>
#include <iostream>
#include <fstream>

#include <string>

#include "plato.h"
#include "guestStructs.h"

#include <sys/types.h>
#include <sys/time.h>

#include <errno.h>

#include <fcntl.h>

using namespace std;

Plato plato;

void openCb() {
  string str;
  char c;
  unsigned long idx;

  unsigned long tmp = plato.readVar("tmp");
  unsigned long flags = plato.readVar("flags");
  unsigned long mode = plato.readVar("mode");

  idx = 0;
  do {
    plato.copy_from_guest(&c, tmp+idx, sizeof(c));
    str.insert(str.end(), c);
    idx++;
    if(idx > 1000000) {
      cerr << "infinite loop, break" << endl;
      return;
    }
  } while(c != '\0');

  cout << "open(" << str << ") flags = " << (void *) flags
       << " mode = " << (void *) mode << endl;
}

void initCb() {
  cout << "initCb" << endl;
  plato.registerBreak("open.c:796:before",openCb);
}  

int main(int argc, char *argv[]) {
  plato.init("plato.conf");

  plato.startEventLoop(initCb);

  return 0;
}
