#include "plato.h"
#include <vector>

using namespace std;

PlatoCheckpoint::PlatoCheckpoint(vector< breakpoint >::iterator bp, 
				 struct pt_regs *regs, bool isUserMode) {
  savedBreak = bp;
  savedRegs = *regs;
  userMode = isUserMode;
}

bool PlatoCheckpoint::isUserMode() {
  return userMode;
}

void PlatoCheckpoint::setBreakData(unsigned long breakIdx, void *breakData) {
  for(unsigned long idx = breakCheckVec.size(); idx <= breakIdx; idx++) {
    breakCheckVec.insert(breakCheckVec.end(), NULL);
  }
  breakCheckVec[breakIdx] = breakData;
}
void *PlatoCheckpoint::getBreakData(unsigned long breakIdx) {
  if(breakIdx >= breakCheckVec.size()) {
    return NULL;
  }

  return breakCheckVec[breakIdx];
}

struct pt_regs PlatoCheckpoint::getSavedRegs() {
  return savedRegs;
}

vector<breakpoint>::iterator PlatoCheckpoint::getSavedBreak() {
  return savedBreak;
}


void PlatoCheckpoint::setUmSetBreakMap(PidMap_t *m) {
  savedUmSetBreakMap = m;
}

PidMap_t *PlatoCheckpoint::getUmSetBreakMap() {
  return savedUmSetBreakMap;
}

void PlatoCheckpoint::setUmQueuedBreakMap(PidMap_t *m) {
  savedUmQueuedBreakMap = m;
}

PidMap_t *PlatoCheckpoint::getUmQueuedBreakMap() {
  return savedUmQueuedBreakMap;
}
