#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <assert.h>
#include <errno.h>
#include <string.h>

#include "uml.h"

int main(int argc, char *argv[]) {
  int fd;
  struct uml_ioc_reset_cow_disk uml;
  int ret;
  unsigned long idx;

  if(argc < 6) {
    printf("usage: resetCowDisk uml_hda cow_basename start_id target_id id_list\n");
    return -1;
  }

  fd = open("/dev/uml",O_RDWR);
  if(fd < 0) {
    perror("open uml device");
    return -1;
  }

  assert(strlen(argv[1]) < (sizeof(uml.umlHda)-1));
  strcpy(uml.umlHda, argv[1]);

  assert(strlen(argv[2]) < (sizeof(uml.cowBaseName)-1));
  strcpy(uml.cowBaseName, argv[2]);

  ret = sscanf(argv[3],"%llu",&uml.startId);
  assert(ret == 1);

  ret = sscanf(argv[4],"%llu",&uml.targetId);
  assert(ret == 1);

  uml.numId = argc - 5;
  uml.idList = (unsigned long long *) malloc(sizeof(unsigned long long) * uml.numId);
  for(idx = 0; idx < uml.numId; idx++) {
    ret = sscanf(argv[idx+5],"%llu",&(uml.idList[idx]));
    assert(ret == 1);
  }

  if(ioctl(fd, UML_IOC_RESET_COW_DISK, &uml)<0) {
    perror("ioctl");
  }

  return 0;
}
  
