#!/usr/bin/perl
use Getopt::Std;
use strict;

my $INTERVAL;
my $MAX_CP = 10;

sub checkpoint {
    my (@cpList, @newArr);
    my ($len, $cp, $idx, $i);

    srand(0);
    while(1) {	
	while(($len = @cpList) >= $MAX_CP) {
	    $idx = int(rand($MAX_CP-1)) + 1;
	    $cp = $cpList[$idx];

	    @newArr = ();
	    for($i = 0; $i < $MAX_CP; $i++) {
		if($i != $idx) {
		    push(@newArr, $cpList[$i]);
		}
	    }
	    @cpList = @newArr;
	    system("./checkctl -r 0 -i $cp > /dev/null 2> /dev/null");
	}
	
	$cp = int(`./checkctl -c`);
	push(@cpList, $cp);
	sleep($INTERVAL);
    }
}

my %options;
getopts("c:",\%options);

$INTERVAL = $options{"c"};
if($INTERVAL eq "") {
    print STDERR "Usage: -c cp_interval\n";
    exit(1);
}

my $child = 0;
if($INTERVAL != 0) {
    $child = fork();
    if($child == 0) {
	sleep(30);
	checkpoint();
    }
}

system("time ./replay.sh > /tmp/terminal.txt 2> /dev/null");
if($child) {
    kill(9, $child);

    wait();
}
print "checkpoint interval $INTERVAL\n";
