#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <assert.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <fcntl.h>
#include <errno.h>
#include <string.h>

#include "uml.h"


int main(int argc, char *argv[]) {
  int ret, opt, fd;
  struct uml_debug_struct dbgCmd;

  if(argc == 1) {
    printf("usage: ./umldbg options\n");
    printf("\t-p debugPrint -- for turning on and off debugging prints\n");
    return 1;
  }

  memset(&dbgCmd, 0, sizeof(dbgCmd));
  
  fd = open("/dev/uml", O_RDWR);
  if(fd < 0) {
    printf("could not open device, not reset\n");
    return 1;
  }

  while((opt = getopt(argc, argv, "p:wt:")) != -1) {
    if(opt == 'p') {
      dbgCmd.cmd = DEBUG_PRINT_CMD;
      ret = sscanf(optarg,"%lu",&dbgCmd.debugPrint); assert(ret == 1);
      ioctl(fd, UML_IOC_DEBUG_CMD, &dbgCmd);
    } else if(opt == 'w') {
      dbgCmd.cmd = DEBUG_WALK_FRAMELIST;
      ioctl(fd, UML_IOC_DEBUG_CMD, &dbgCmd);
    } else if(opt == 't') {
      dbgCmd.cmd = DEBUG_PRINT_TD;
      ret = sscanf(optarg,"%lx",&dbgCmd.addr); assert(ret == 1);
      ioctl(fd, UML_IOC_DEBUG_CMD, &dbgCmd);
    } else {
      printf("invalid switch\n");
      assert(0);
    }
  }

  //ioctl(fd, UML_IOC_RESTART_UML, 0);
  ioctl(fd, UML_IOC_ERESET_UML, 0);

  close(fd);
  return 0;
}
