#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <asm/unistd.h>
#include <linux/autoconf.h>
#include <revirt/rlog.h>
#include <revirt/ztrace.h>
#include <revirt/syscalls.h>
#include <string.h>

#include "library.h"

/* FIXME -- just for now */
#define ZTRACE_GETSTATE 8
#define ZTRACE_PEEK 18

struct map_entry {
    unsigned int eip;
    char name[50];
};

struct map_entry map[20000];

int openmap(const char * fn) {
    FILE * f;
    int i=0;
    char c;

    if((f=fopen(fn, "r"))==NULL) {
	perror("open");
	exit(1);
    }
    for(i=0; fscanf(f, "%x %c %s", &map[i].eip, &c, map[i].name); i++) {
	//printf("%x %s\n", map[i].eip, map[i].name);
	if(map[i].eip > 0x80000000 || map[i].eip < 0x70000000) 
	    break;
    }
    return 0;
}

int findmap(unsigned long n, char * name) {
    unsigned long p=0;
    int i;
    if(n < 0x70000000){
	name[0]=0;
	name[1]=0;
	return 0;
    }
    if(n > 0x80000000){
	name[0]=0;
	name[1]=0;
	return 0;
    }
    for(i=0; i<20000; i++) {
	if(map[i].eip > n)
	    break;
	p=n;
    }
    if(i>=20000) {
	name[0]=0;
	name[1]=0;
	return 0;
    } else {
	strncpy(name, map[i-1].name, 100);
	return 0;
    }
}

int main(int argc, char * argv[]) {
	struct ztrace_state_struct zt_state;
	int pid;
	unsigned long top = 0x7fffffff,
		esp, eip, i;
	int incr=4;
	int hasmap=0;
	char name[500];


	name[0]=0;
		
	if(argc < 2) {
		fprintf(stderr, "Usage: %s pid [mapname]\n", argv[0]);
		exit(1);
	} else if(argc == 3) {
	    	openmap(argv[2]);
		hasmap=1;
#if 0
		if(argv[2][0] == '-') {
			incr = -4;
		}	
#endif
	}
	pid=atoi(argv[1]);
	if(ztrace(ZTRACE_GETSTATE, pid,0,&zt_state))
		perror("getstate");
	esp = (unsigned long) zt_state.regs.esp;
#if 0
	printf("frame 0: esp = 0x%x\n", esp);
	if(ztrace(ZTRACE_PEEK, pid, esp, &ebp)) {
		perror("ztrace_peek");
	}
	ebp = zt_state.regs.ebp;
	do {
		printf("frame %d: ebp = 0x%x\n", count, ebp);
		if(ebp < esp || ebp > top)
			break;
		if(ztrace(ZTRACE_PEEK, pid, ebp + 4, &eip)) {
			perror("ztrace_peek");
			break;
		}
		printf("frame %d: eip = 0x%x\n", count, eip);
		if(ztrace(ZTRACE_PEEK, pid, ebp , &ebp)) {
			perror("ztrace_peek");
			break;
		}
	} while(count++ < 16);
#endif
	if(incr > 0) {
	 for(;esp < top; esp+=4) {
		if(ztrace(ZTRACE_PEEK, pid, esp, &eip)) {
			perror("ztrace_peek");
			break;
		}
		if(hasmap) {
		    findmap(eip, name);
		}
		printf("0x%x: 0x%x\t%s\n", esp, eip, name);
	 }
	} else {
	 for(i=top-4; i > esp; i -= 4) {
		if(ztrace(ZTRACE_PEEK, pid, i, &eip)) {
			perror("ztrace_peek");
			break;
		}
		if(hasmap) {
		    findmap(eip, name);
		}
		printf("0x%x: 0x%x\t%s\n", i, eip, name);
 	 }
	}
	return(0);
}
