/*
 * chkpt_interval.c
 */
#include <stdlib.h>
#include <stdio.h>
#include <asm/unistd.h>
#include <errno.h>
#include <time.h>
#include <string.h>

#include <unistd.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <fcntl.h>

#include <revirt/rlog.h>
#include <revirt/ztrace.h>
#include <revirt/syscalls.h>
#include <revirt/flags.h>

#include <sys/vfs.h>

#include "library.h"
#include "lib-checkpoint.h"

#include "uml.h"

#define MAX_DATAPOINTS 30

int main(int argc, char * argv[]) {
    long long bytes_start, bytes_end, blocks;
    int marker;
    struct statfs sfs;

    if(argc!=2) {
    	fprintf(stderr, "Usage: %d marker\n", argv[0]);
	exit(1);
    }
    marker=atoi(argv[1]);

    /* Enable event waiting */
    fprintf(stderr, "Enabling event waiting\n");
    if(waitevent_enable(1)<0) {
	    perror("waitevent_enable");
    	    exit(1);
    }

    fprintf(stderr, "Setting marker for %d...\n", marker);
    if(waitevent_marker(marker)<0) {
	    perror("waitevent_marker");
	    exit(1);
    }

    fprintf(stderr, "Waiting for first marker...\n");
    waitevent_wait();

    if(!waitevent_is_waiting()) {
    	fprintf(stderr, "Process wasn't waiting!  Read invalid.\n");
    	fprintf(stdout, "Process wasn't waiting!  Read invalid.\n");
    }

    statfs("/checkpoint/", &sfs);
    bytes_start=(long long)sfs.f_bfree * sfs.f_bsize;

    if(waitevent_is_waiting) {
    	fprintf(stderr, "Continuing...\n");
    	waitevent_cont();
    }

    fprintf(stderr, "Waiting for second marker...\n");
    waitevent_wait();

    if(!waitevent_is_waiting()) {
    	fprintf(stderr, "Process wasn't waiting!  Read invalid.\n");
    	fprintf(stdout, "Process wasn't waiting!  Read invalid.\n");
    }

    statfs("/checkpoint/", &sfs);
    bytes_end=(long long)sfs.f_bfree * sfs.f_bsize;

    if(waitevent_is_waiting) {
    	fprintf(stderr, "Continuing...\n");
    	waitevent_cont();
    }

    blocks = (bytes_start - bytes_end) / 1024;
    fprintf(stderr, "%lld  (%lld - %lld)\n", blocks, bytes_start, bytes_end);
    printf("%lld  (%lld - %lld)\n", blocks, bytes_start, bytes_end);

    waitevent_enable(0);

    return 0;
}
