/*
 * release.c
 *
 * If ever we have a replaying process orphaned and unable to run, 
 * this program will attach and detach, allowing it to execute to completion.
 */

/*
 * replay/demon.h includes linux/sched.h, which includes just about everything
 */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <asm/unistd.h>

#include <linux/autoconf.h>
#include <revirt/rlog.h>
#include <revirt/ztrace.h>
#include <revirt/syscalls.h>

#include "library.h"

int main(int argc, char * argv[]) {
	int detach=1, pid;
	if(argc < 2) {
		fprintf(stderr, "Usage: %s pid [detach]\n", argv[0]);
	}
	pid=atoi(argv[1]);
	if(argc == 3) {
		detach=atoi(argv[2]);
	}
	printf("Releasing pid %d, detach==%d\n", pid, detach);
	ztrace(ZTRACE_DETACH, atoi(argv[1]),0,(void *)detach);
	return(0);
}
