/*
 * resume.c
 *
 * If ever we have a replaying process orphaned and unable to run, 
 * this program will attach and detach, allowing it to execute to completion.
 */

/*
 * replay/demon.h includes linux/sched.h, which includes just about everything
 */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <asm/unistd.h>

#include <linux/autoconf.h>
#include <revirt/rlog.h>
#include <revirt/ztrace.h>
#include <revirt/syscalls.h>

#include "library.h"

int main(int argc, char * argv[]) {
	int i;
	int pause=0;
	if(argc < 2) {
		fprintf(stderr, "Usage: %s pid [pid ...]\n", argv[0]);
	}

	for(i=1; i<argc; i++) {
	    if(argv[i][0]=='-') {
		printf("Pausing only.\n");
		pause=1;
	    } else {
		printf("Detaching from pid %d\n", atoi(argv[i]));
		ztrace(ZTRACE_RESUME, atoi(argv[i]),pause,0);
	    }
	}
	return(0);
}
