#include <stdlib.h>
#include <stdio.h>
#include <asm/unistd.h>
#include <errno.h>
#include <time.h>
#include <string.h>

#include <unistd.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#include <revirt/rlog.h>
#include <revirt/ztrace.h>
#include <revirt/syscalls.h>
#include <revirt/flags.h>

#include "library.h"
#include "lib-checkpoint.h"

#include "uml.h"

struct {
    char * cmdstring;
    int cmd;
    int takes_val;
} commands[] = {
    { .cmdstring="enable", .takes_val=1, .cmd=WAITEVENT_ENABLE },
    { .cmdstring="setmark", .takes_val=1, .cmd=WAITEVENT_SETMARK },
    { .cmdstring="cont", .takes_val=0, .cmd=WAITEVENT_CONT },
    { .cmdstring="wait", .takes_val=0, .cmd=WAITEVENT_WAIT },
    { .cmdstring="is_waiting", .takes_val=0, .cmd=WAITEVENT_IS_WAITING },
    { .cmdstring=NULL }
};

int main(int argc, char * argv[]) {
    int ret, i, val=0;
    if(argc<2 || argc>3)
	goto usage;
    
    i=0;

    while((commands[i].cmdstring) && strcmp(commands[i].cmdstring, argv[1]))
    	i++;

    if(!commands[i].cmdstring) {
	fprintf(stderr, "Command not found: %s\n", argv[1]);
	goto usage;
    }

    if(commands[i].takes_val) {
	if(argc<3) {
	    fprintf(stderr, "Command %s requires a value.\n", commands[i].cmdstring);
	    goto usage;
	}
	val=atoi(argv[2]);
    }
    ret=ztrace_waitevent(commands[i].cmd, val);
    printf("waitevent(%s, %d) returned %d\n", 
    		commands[i].cmdstring,
		val,
		ret);

    return 0;
   usage:
    fprintf(stderr, "Usage: %s (enable|setmark|cont|wait|is_waiting) [val]\n", 
    		argv[0]);
    exit(1);
}
